/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package libconnect.core;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintStream;

/**
 *
 * @author chris
 */
public class HabboPacketBuilder extends ByteArrayOutputStream {
    
    public HabboPacketBuilder(String header) throws HabboException, IOException{
        if(header.length() != 2) throw new HabboException("Header Must be 2 Characters");
        write(header.getBytes());
    }
    
    public HabboPacket createPacket(){
        return new HabboPacket(toByteArray());
    }

    public void writeFromBinaryString(String s) throws IOException {
        ByteArrayOutputStream bout = new ByteArrayOutputStream();
        PrintStream pout = new PrintStream(bout);
        char[] dat = s.toCharArray();
        boolean inBrack = false;
        StringBuilder b = new StringBuilder();
        for(char c : dat){
            if(c == '['){
                inBrack = true;
            } else if(c == ']') {
                pout.print(((char)(int) Integer.valueOf(b.toString(), 15)));
                b.delete(0, b.length());
                inBrack = false;
            } else if(inBrack) {
                b.append(c);
            } else {
                pout.print(c);
            }
        }
        pout.flush();
        write(bout.toByteArray());
    }

}
